<?php
define("MIFARE_EMULATED_CARD", dirname(__FILE__) . "/emulated_card.bin");

function mifare_acquire_lock() {
  return true;
}

function mifare_init_library() {
  return true;
}

function mifare_open_reader() {
  return true;
}

function mifare_find_card() {
  if (!file_exists(MIFARE_EMULATED_CARD))
    return false;
  $card = fopen(MIFARE_EMULATED_CARD, "r");
  $cardId = fread($card, 8);
  fclose($card);
  if (strlen($cardId) != 8)
    return false;
  return $cardId;
}

function mifare_read_card($cardId, $addr, $len) {
  if (!is_string($cardId))
    return false;
  if (!file_exists(MIFARE_EMULATED_CARD))
    return false;
  $cardData = file_get_contents(MIFARE_EMULATED_CARD);
  if (substr($cardData, 0, 8) != $cardId)
    return false;
  if (strlen($cardData) != 64)
    return false;
  return substr($cardData, $addr, $len);
}

function mifare_write_card($cardId, $addr, $writeData) {
  if (!is_string($cardId))
    return false;
  if (!file_exists(MIFARE_EMULATED_CARD))
    return false;
  $cardData = file_get_contents(MIFARE_EMULATED_CARD);
  if (substr($cardData, 0, 8) != $cardId)
    return false;
  if (strlen($cardData) != 64)
    return false;
  $cardData = substr_replace($cardData, $writeData, $addr, strlen($writeData));
  return file_put_contents(MIFARE_EMULATED_CARD, $cardData);
}
?>